From 0277fa4de47213667336c5573183c2615f4477ce Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sat, 21 Sep 2024 08:17:54 +0300
Subject: [PATCH 34/34] sdl3: Update key names

sdl3 has changed key names to all-uppercase; SDLK_x -> SDLK_X

See RM #899

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 client/gui-sdl3/citydlg.c   |  6 +--
 client/gui-sdl3/diplodlg.c  |  6 +--
 client/gui-sdl3/mapctrl.c   | 78 ++++++++++++++++++-------------------
 client/gui-sdl3/menu.c      | 74 +++++++++++++++++------------------
 client/gui-sdl3/optiondlg.c |  6 +--
 client/gui-sdl3/plrdlg.c    | 10 ++---
 6 files changed, 90 insertions(+), 90 deletions(-)

diff --git a/client/gui-sdl3/citydlg.c b/client/gui-sdl3/citydlg.c
index a150084b27..0c75eff8a6 100644
--- a/client/gui-sdl3/citydlg.c
+++ b/client/gui-sdl3/citydlg.c
@@ -3699,7 +3699,7 @@ void real_city_dialog_popup(struct city *pcity)
   if (owner == client.conn.playing) {
     set_wstate(buf, FC_WS_NORMAL);
   }
-  buf->key = SDLK_c;
+  buf->key = SDLK_C;
   add_to_gui_list(ID_CITY_DLG_CHANGE_PROD_BUTTON, buf);
   /* -------- */
 
@@ -3711,7 +3711,7 @@ void real_city_dialog_popup(struct city *pcity)
   buf->size.x = area.x + adj_size(7) + (buf->size.w + adj_size(2));
   buf->size.y = area.y + area.h - buf->size.h - adj_size(5);
   pcity_dlg->buy_button = buf;
-  buf->key = SDLK_h;
+  buf->key = SDLK_H;
   if (city_can_buy(pcity)) {
     set_wstate(buf, FC_WS_NORMAL);
   }
@@ -3723,7 +3723,7 @@ void real_city_dialog_popup(struct city *pcity)
   buf->info_label = create_utf8_from_char_fonto(_("Citizen Governor"),
                                                 FONTO_ATTENTION);
   buf->action = cma_city_dlg_callback;
-  buf->key = SDLK_a;
+  buf->key = SDLK_A;
   buf->size.x = area.x + adj_size(7) + (buf->size.w + adj_size(2)) * 2;
   buf->size.y = area.y + area.h - buf->size.h - adj_size(5);
   if (owner == client.conn.playing) {
diff --git a/client/gui-sdl3/diplodlg.c b/client/gui-sdl3/diplodlg.c
index 73599c775a..d1559d05e4 100644
--- a/client/gui-sdl3/diplodlg.c
+++ b/client/gui-sdl3/diplodlg.c
@@ -1645,7 +1645,7 @@ void popup_diplomacy_dialog(struct player *pplayer)
       buf->string_utf8->fgcol
         = *get_theme_color(COLOR_THEME_DIPLODLG_MEETING_TEXT);
       buf->data.player = pplayer;
-      buf->key = SDLK_c;
+      buf->key = SDLK_C;
       add_to_gui_list(ID_BUTTON, buf);
       buf->size.w = MAX(buf->next->size.w, buf->size.w);
       buf->next->size.w = buf->size.w;
@@ -1666,7 +1666,7 @@ void popup_diplomacy_dialog(struct player *pplayer)
       buf->action = withdraw_vision_dlg_callback;
       set_wstate(buf, FC_WS_NORMAL);
       buf->data.player = pplayer;
-      buf->key = SDLK_w;
+      buf->key = SDLK_W;
       buf->string_utf8->fgcol
         = *get_theme_color(COLOR_THEME_DIPLODLG_MEETING_TEXT);
       add_to_gui_list(ID_BUTTON, buf);
@@ -1686,7 +1686,7 @@ void popup_diplomacy_dialog(struct player *pplayer)
     buf->action = call_meeting_dlg_callback;
     set_wstate(buf, FC_WS_NORMAL);
     buf->data.player = pplayer;
-    buf->key = SDLK_m;
+    buf->key = SDLK_M;
     buf->string_utf8->fgcol = *get_theme_color(COLOR_THEME_DIPLODLG_MEETING_TEXT);
     add_to_gui_list(ID_BUTTON, buf);
     buf->size.w = MAX(buf->next->size.w, buf->size.w);
diff --git a/client/gui-sdl3/mapctrl.c b/client/gui-sdl3/mapctrl.c
index 4eed53d663..ab7a1603ef 100644
--- a/client/gui-sdl3/mapctrl.c
+++ b/client/gui-sdl3/mapctrl.c
@@ -1523,7 +1523,7 @@ void popup_unitinfo_window(void)
   fc_snprintf(buf, sizeof(buf), "%s (%s)", _("Revolution"), "Ctrl+Shift+G");
   pwidget->info_label = create_utf8_from_char_fonto(buf, FONTO_ATTENTION);
   pwidget->action = revolution_callback;
-  pwidget->key = SDLK_g;
+  pwidget->key = SDLK_G;
   pwidget->mod = SDL_KMOD_CTRL | SDL_KMOD_SHIFT;
 
   add_to_gui_list(ID_REVOLUTION, pwidget);
@@ -1714,7 +1714,7 @@ void popup_minimap_window(void)
   pwidget->info_label = create_utf8_from_char_fonto(buf, FONTO_ATTENTION);
   pwidget->info_label->style |= SF_CENTER;
   pwidget->action = cities_action_callback;
-  pwidget->key = SDLK_f;
+  pwidget->key = SDLK_F;
   pwidget->mod = SDL_KMOD_CTRL;
 
   add_to_gui_list(ID_CITIES, pwidget);
@@ -2522,31 +2522,31 @@ bool map_event_handler(SDL_KeyboardEvent *key)
         movedir = DIR8_NORTHWEST;
         break;
 
-        /* *** map view settings *** */
+        /* *** Map view settings *** */
 
-        /* show city outlines - Ctrl+y */
-      case SDLK_y:
+        /* Show city outlines - Ctrl+y */
+      case SDLK_Y:
         if (LCTRL || RCTRL) {
           key_city_outlines_toggle();
         }
         return FALSE;
 
         /* Show map grid - Ctrl+g */
-      case SDLK_g:
+      case SDLK_G:
         if (LCTRL || RCTRL) {
           key_map_grid_toggle();
         }
         return FALSE;
 
-        /* show national borders - Ctrl+b */
-      case SDLK_b:
+        /* Show national borders - Ctrl+b */
+      case SDLK_B:
         if (LCTRL || RCTRL) {
           key_map_borders_toggle();
         }
         return FALSE;
 
-      case SDLK_n:
-        /* show native tiles - Ctrl+Shift+n */ 
+      case SDLK_N:
+        /* Show native tiles - Ctrl+Shift+n */ 
         if ((LCTRL || RCTRL) && (LSHIFT || RSHIFT)) {
           key_map_native_toggle();
         } else if (LCTRL || RCTRL) {
@@ -2555,9 +2555,9 @@ bool map_event_handler(SDL_KeyboardEvent *key)
         }
         return FALSE;
 
-        /* show city growth Ctrl+o */
-        /* show pollution - Ctrl+Shift+o */
-      case SDLK_o:
+        /* Show city growth Ctrl+o */
+        /* Show pollution - Ctrl+Shift+o */
+      case SDLK_O:
         if (LCTRL || RCTRL) {
           if (LSHIFT || RSHIFT) {
             key_pollution_toggle();
@@ -2567,70 +2567,70 @@ bool map_event_handler(SDL_KeyboardEvent *key)
         }
         return FALSE;
 
-        /* show bases - Ctrl+Shift+f */
-      case SDLK_f:
+        /* Show bases - Ctrl+Shift+f */
+      case SDLK_F:
         if ((LCTRL || RCTRL) && (LSHIFT || RSHIFT)) {
           request_toggle_bases();
         }
         return FALSE;
 
-      /* show city productions - Ctrl+p */
-      case SDLK_p:
+      /* Show city productions - Ctrl+p */
+      case SDLK_P:
         if (LCTRL || RCTRL) {
           key_city_productions_toggle();
         }
         return FALSE;
 
-        /* show city trade routes - Ctrl+d */
-      case SDLK_d:
+        /* Show city trade routes - Ctrl+d */
+      case SDLK_D:
         if (LCTRL || RCTRL) {
           key_city_trade_routes_toggle();
         }
         return FALSE;
 
-        /* *** some additional shortcuts that work in the SDL client only *** */
+        /* *** Some additional shortcuts that work in the SDL client only *** */
 
-        /* show terrain - Ctrl+Shift+t */
-      case SDLK_t:
+        /* Show terrain - Ctrl+Shift+t */
+      case SDLK_T:
         if ((LCTRL || RCTRL) && (LSHIFT || RSHIFT)) {
           key_terrain_toggle();
         }
         return FALSE;
 
-        /* (show coastline) */
+        /* (Show coastline) */
 
-      /* (show roads and rails) */
+      /* (Show roads and rails) */
 
-      /* show irrigation - Ctrl+i */
-      case SDLK_i:
+      /* Show irrigation - Ctrl+i */
+      case SDLK_I:
         if (LCTRL || RCTRL) {
           key_irrigation_toggle();
         }
         return FALSE;
 
-        /* show mines - Ctrl+m */
-      case SDLK_m:
+        /* Show mines - Ctrl+m */
+      case SDLK_M:
         if (LCTRL || RCTRL) {
           key_mines_toggle();
         }
         return FALSE;
 
-        /* show resources - Ctrl+s */
-      case SDLK_s:
+        /* Show resources - Ctrl+s */
+      case SDLK_S:
         if (LCTRL || RCTRL) {
           key_resources_toggle();
         }
         return FALSE;
 
-        /* show huts - Ctrl+h */
-      case SDLK_h:
+        /* Show huts - Ctrl+h */
+      case SDLK_H:
         if (LCTRL || RCTRL) {
           key_huts_toggle();
         }
         return FALSE;
 
-        /* show cities - Ctrl+c */
-      case SDLK_c:
+        /* Show cities - Ctrl+c */
+      case SDLK_C:
         if (LCTRL || RCTRL) {
           request_toggle_cities();
         } else {
@@ -2638,22 +2638,22 @@ bool map_event_handler(SDL_KeyboardEvent *key)
         }
         return FALSE;
 
-        /* show units - Ctrl+u */
-      case SDLK_u:
+        /* Show units - Ctrl+u */
+      case SDLK_U:
         if (LCTRL || RCTRL) {
           key_units_toggle();
         }
         return FALSE;
 
-        /* (show focus unit) */
+        /* (Show focus unit) */
 
         /* Show city output - Ctrl+v */
-      case SDLK_v:
+      case SDLK_V:
         key_city_output_toggle();
         return FALSE;
 
         /* Show fog of war - Ctrl+w */
-      case SDLK_w:
+      case SDLK_W:
         if (LCTRL || RCTRL) {
           key_fog_of_war_toggle();
         }
diff --git a/client/gui-sdl3/menu.c b/client/gui-sdl3/menu.c
index 1f2dc6cbf1..a5dc0bdcd5 100644
--- a/client/gui-sdl3/menu.c
+++ b/client/gui-sdl3/menu.c
@@ -422,7 +422,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_w;
+  buf->key = SDLK_W;
   add_to_gui_list(ID_UNIT_ORDER_WAIT, buf);
   /* --------- */
 
@@ -435,7 +435,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_n;
+  buf->key = SDLK_N;
   buf->mod = SDL_KMOD_SHIFT;
   add_to_gui_list(ID_UNIT_ORDER_NUKE, buf);
   /* --------- */
@@ -449,7 +449,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_d;
+  buf->key = SDLK_D;
   add_to_gui_list(ID_UNIT_ORDER_DIPLOMAT_DLG, buf);
   /* --------- */
 
@@ -461,7 +461,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_d;
+  buf->key = SDLK_D;
   buf->mod = SDL_KMOD_SHIFT;
   add_to_gui_list(ID_UNIT_ORDER_DISBAND, buf);
   /* --------- */
@@ -474,7 +474,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_u;
+  buf->key = SDLK_U;
   buf->mod = SDL_KMOD_SHIFT;
   add_to_gui_list(ID_UNIT_ORDER_UPGRADE, buf);
   /* --------- */
@@ -487,7 +487,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_o;
+  buf->key = SDLK_O;
   buf->mod = SDL_KMOD_SHIFT;
   add_to_gui_list(ID_UNIT_ORDER_CONVERT, buf);
   /* --------- */
@@ -501,7 +501,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_g;
+  buf->key = SDLK_G;
   buf->mod = SDL_KMOD_SHIFT;
   add_to_gui_list(ID_UNIT_ORDER_RETURN, buf);
   /* --------- */
@@ -514,7 +514,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_t;
+  buf->key = SDLK_T;
   add_to_gui_list(ID_UNIT_ORDER_GOTO_CITY, buf);
   /* --------- */
 
@@ -526,7 +526,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_t;
+  buf->key = SDLK_T;
   add_to_gui_list(ID_UNIT_ORDER_AIRLIFT, buf);
   /* --------- */
 
@@ -538,7 +538,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_g;
+  buf->key = SDLK_G;
   add_to_gui_list(ID_UNIT_ORDER_GOTO, buf);
   /* --------- */
 
@@ -550,7 +550,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_q;
+  buf->key = SDLK_Q;
   add_to_gui_list(ID_UNIT_ORDER_PATROL, buf);
   /* --------- */
 
@@ -563,7 +563,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_i;
+  buf->key = SDLK_I;
   buf->mod = SDL_KMOD_CTRL;
   add_to_gui_list(ID_UNIT_ORDER_CONNECT_IRRIGATE, buf);
   /* --------- */
@@ -582,7 +582,7 @@ void create_units_order_widgets(void)
     set_wstate(buf, FC_WS_NORMAL);
     buf->action = unit_order_callback;
     buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-    buf->key = SDLK_r;
+    buf->key = SDLK_R;
     buf->mod = SDL_KMOD_CTRL;
     add_to_gui_list(ID_UNIT_ORDER_CONNECT_ROAD, buf);
   }
@@ -601,7 +601,7 @@ void create_units_order_widgets(void)
     set_wstate(buf, FC_WS_NORMAL);
     buf->action = unit_order_callback;
     buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-    buf->key = SDLK_l;
+    buf->key = SDLK_L;
     buf->mod = SDL_KMOD_CTRL;
     add_to_gui_list(ID_UNIT_ORDER_CONNECT_RAILROAD, buf);
   }
@@ -615,7 +615,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_x;
+  buf->key = SDLK_X;
   add_to_gui_list(ID_UNIT_ORDER_AUTO_EXPLORE, buf);
   /* --------- */
 
@@ -628,7 +628,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_a;
+  buf->key = SDLK_A;
   add_to_gui_list(ID_UNIT_ORDER_AUTO_SETTLER, buf);
   /* --------- */    
 
@@ -641,7 +641,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_s;
+  buf->key = SDLK_S;
   buf->mod = SDL_KMOD_SHIFT;
   add_to_gui_list(ID_UNIT_ORDER_WAKEUP_OTHERS, buf);
   /* --------- */
@@ -656,7 +656,7 @@ void create_units_order_widgets(void)
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
   buf->mod = SDL_KMOD_SHIFT;
-  buf->key = SDLK_t;
+  buf->key = SDLK_T;
   add_to_gui_list(ID_UNIT_ORDER_UNLOAD_TRANSPORTER, buf);
   /* --------- */
 
@@ -668,7 +668,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_l;
+  buf->key = SDLK_L;
   add_to_gui_list(ID_UNIT_ORDER_BOARD, buf);
   /* --------- */
 
@@ -680,7 +680,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_u;
+  buf->key = SDLK_U;
   add_to_gui_list(ID_UNIT_ORDER_DEBOARD, buf);
   /* --------- */
 
@@ -693,7 +693,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_h;
+  buf->key = SDLK_H;
   add_to_gui_list(ID_UNIT_ORDER_HOMECITY, buf);
   /* --------- */
 
@@ -705,7 +705,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_p;
+  buf->key = SDLK_P;
   buf->mod = SDL_KMOD_SHIFT;
   add_to_gui_list(ID_UNIT_ORDER_PILLAGE, buf);
   /* --------- */
@@ -718,7 +718,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_s;
+  buf->key = SDLK_S;
   add_to_gui_list(ID_UNIT_ORDER_SENTRY, buf);
   /* --------- */
 
@@ -731,7 +731,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label =  create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_j;
+  buf->key = SDLK_J;
   add_to_gui_list(ID_UNIT_ORDER_PARADROP, buf);
   /* --------- */
 
@@ -744,7 +744,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_p;
+  buf->key = SDLK_P;
   order_clean_button = buf;
   add_to_gui_list(ID_UNIT_ORDER_CLEAN, buf);
   /* --------- */
@@ -758,7 +758,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_e;
+  buf->key = SDLK_E;
   buf->mod = SDL_KMOD_SHIFT;
   order_airbase_button = buf;
   add_to_gui_list(ID_UNIT_ORDER_AIRBASE, buf);
@@ -772,7 +772,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_f;
+  buf->key = SDLK_F;
   add_to_gui_list(ID_UNIT_ORDER_FORTIFY, buf);
   /* --------- */
 
@@ -785,7 +785,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_f;
+  buf->key = SDLK_F;
   buf->mod = SDL_KMOD_SHIFT;
   order_fortress_button = buf;
   add_to_gui_list(ID_UNIT_ORDER_FORTRESS, buf);
@@ -800,7 +800,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_o;
+  buf->key = SDLK_O;
   order_transform_button = buf;
   add_to_gui_list(ID_UNIT_ORDER_TRANSFORM, buf);
   /* --------- */
@@ -814,7 +814,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_m;
+  buf->key = SDLK_M;
   add_to_gui_list(ID_UNIT_ORDER_MINE, buf);
 
   order_mine_button = buf;
@@ -828,7 +828,7 @@ void create_units_order_widgets(void)
                          | WF_WIDGET_HAS_INFO_LABEL);
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
-  buf->key = SDLK_i;
+  buf->key = SDLK_I;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
   add_to_gui_list(ID_UNIT_ORDER_IRRIGATE, buf);
 
@@ -843,7 +843,7 @@ void create_units_order_widgets(void)
                          | WF_WIDGET_HAS_INFO_LABEL);
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
-  buf->key = SDLK_i;
+  buf->key = SDLK_I;
   buf->mod = SDL_KMOD_SHIFT;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
   add_to_gui_list(ID_UNIT_ORDER_CULTIVATE, buf);
@@ -859,7 +859,7 @@ void create_units_order_widgets(void)
                          | WF_WIDGET_HAS_INFO_LABEL);
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
-  buf->key = SDLK_m;
+  buf->key = SDLK_M;
   buf->mod = SDL_KMOD_SHIFT;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
   add_to_gui_list(ID_UNIT_ORDER_PLANT, buf);
@@ -876,7 +876,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_r;
+  buf->key = SDLK_R;
   add_to_gui_list(ID_UNIT_ORDER_TRADE_ROUTE, buf);
 
   order_trade_button = buf;
@@ -891,7 +891,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_r;
+  buf->key = SDLK_R;
   add_to_gui_list(ID_UNIT_ORDER_ROAD, buf);
 
   order_road_button = buf;
@@ -906,7 +906,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_b;
+  buf->key = SDLK_B;
   add_to_gui_list(ID_UNIT_ORDER_BUILD_WONDER, buf);
   /* --------- */
 
@@ -919,7 +919,7 @@ void create_units_order_widgets(void)
   set_wstate(buf, FC_WS_NORMAL);
   buf->action = unit_order_callback;
   buf->info_label = create_utf8_from_char_fonto(cbuf, FONTO_DEFAULT);
-  buf->key = SDLK_b;
+  buf->key = SDLK_B;
   add_to_gui_list(ID_UNIT_ORDER_BUILD_CITY, buf);
 
   order_build_add_to_city_button = buf;
diff --git a/client/gui-sdl3/optiondlg.c b/client/gui-sdl3/optiondlg.c
index 049d760c50..088621ee4f 100644
--- a/client/gui-sdl3/optiondlg.c
+++ b/client/gui-sdl3/optiondlg.c
@@ -887,7 +887,7 @@ static struct option_dialog *option_dialog_new(void)
                                                _("Help Browser"),
                                                FONTO_ATTENTION, 0);
   widget->action = help_browser_callback;
-  widget->key = SDLK_h;
+  widget->key = SDLK_H;
   if (client.conn.established) {
     set_wstate(widget, FC_WS_NORMAL);
   }
@@ -899,7 +899,7 @@ static struct option_dialog *option_dialog_new(void)
                                                _("Leave Game"),
                                                FONTO_ATTENTION, 0);
   widget->action = disconnect_callback;
-  widget->key = SDLK_q;
+  widget->key = SDLK_Q;
   if (client.conn.established) {
     set_wstate(widget, FC_WS_NORMAL);
   }
@@ -911,7 +911,7 @@ static struct option_dialog *option_dialog_new(void)
                                                _("Quit"),
                                                FONTO_ATTENTION, 0);
   widget->action = exit_callback;
-  widget->key = SDLK_q;
+  widget->key = SDLK_Q;
   set_wstate(widget, FC_WS_NORMAL);
   widget_resize(widget, widget->size.w, widget->size.h + adj_size(4));
   add_to_gui_list(ID_OPTIONS_EXIT_BUTTON, widget);
diff --git a/client/gui-sdl3/plrdlg.c b/client/gui-sdl3/plrdlg.c
index ceaad9c185..96c8902b6c 100644
--- a/client/gui-sdl3/plrdlg.c
+++ b/client/gui-sdl3/plrdlg.c
@@ -389,35 +389,35 @@ void popup_players_dialog(bool raise)
                               (sdl3_client_flags & CF_DRAW_PLAYERS_NEUTRAL_STATUS),
                               WF_RESTORE_BACKGROUND);
         buf->action = toggle_draw_neutral_status_callback;
-        buf->key = SDLK_n;
+        buf->key = SDLK_N;
       break;
       case DS_WAR:
         buf = create_checkbox(pwindow->dst,
                               (sdl3_client_flags & CF_DRAW_PLAYERS_WAR_STATUS),
                               WF_RESTORE_BACKGROUND);
         buf->action = toggle_draw_war_status_callback;
-        buf->key = SDLK_w;
+        buf->key = SDLK_W;
       break;
       case DS_CEASEFIRE:
         buf = create_checkbox(pwindow->dst,
                               (sdl3_client_flags & CF_DRAW_PLAYERS_CEASEFIRE_STATUS),
                               WF_RESTORE_BACKGROUND);
         buf->action = toggle_draw_ceasefire_status_callback;
-        buf->key = SDLK_c;
+        buf->key = SDLK_C;
       break;
       case DS_PEACE:
         buf = create_checkbox(pwindow->dst,
                               (sdl3_client_flags & CF_DRAW_PLAYERS_PEACE_STATUS),
                               WF_RESTORE_BACKGROUND);
         buf->action = toggle_draw_peace_status_callback;
-        buf->key = SDLK_p;
+        buf->key = SDLK_P;
       break;
       case DS_ALLIANCE:
         buf = create_checkbox(pwindow->dst,
                               (sdl3_client_flags & CF_DRAW_PLAYERS_ALLIANCE_STATUS),
                               WF_RESTORE_BACKGROUND);
         buf->action = toggle_draw_alliance_status_callback;
-        buf->key = SDLK_a;
+        buf->key = SDLK_A;
       break;
       default:
         /* no contact */
-- 
2.45.2