From 4e26be0adee3a34ec61af90521cef18774de85eb Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Wed, 2 Oct 2024 04:47:21 +0300
Subject: [PATCH 39/39] governments.rulesets: Correct "palyer" as "player"

See RM #927

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/alien/governments.ruleset         | 2 +-
 data/civ1/governments.ruleset          | 2 +-
 data/civ2/governments.ruleset          | 2 +-
 data/civ2civ3/governments.ruleset      | 2 +-
 data/classic/governments.ruleset       | 2 +-
 data/goldkeep/governments.ruleset      | 2 +-
 data/granularity/governments.ruleset   | 2 +-
 data/multiplayer/governments.ruleset   | 2 +-
 data/ruledit/comments-3.3.txt          | 2 +-
 data/sandbox/governments.ruleset       | 2 +-
 data/stub/governments.ruleset          | 2 +-
 data/webperimental/governments.ruleset | 2 +-
 12 files changed, 12 insertions(+), 12 deletions(-)

diff --git a/data/alien/governments.ruleset b/data/alien/governments.ruleset
index 829a6705ef..86f90ec6f1 100644
--- a/data/alien/governments.ruleset
+++ b/data/alien/governments.ruleset
@@ -45,7 +45,7 @@ during_revolution = "Anarchy"
 ; graphic_alt  = alternate graphics tag if preferred is not found;
 ;                should be a standard tag if preferred is not;
 ;                otherwise may be "-"
-; sound        = Sound tag for the audio to play when palyer switch
+; sound        = Sound tag for the audio to play when player switch
 ;                to government.
 ; sound_alt    = Alternative sound tag, in case primary one is not found.
 ; sound_alt2   = Second alternative sound tag, in case neither primary tag
diff --git a/data/civ1/governments.ruleset b/data/civ1/governments.ruleset
index 73298f00ca..ce6ac0084e 100644
--- a/data/civ1/governments.ruleset
+++ b/data/civ1/governments.ruleset
@@ -46,7 +46,7 @@ during_revolution = "Anarchy"
 ; graphic_alt  = alternate graphics tag if preferred is not found;
 ;                should be a standard tag if preferred is not;
 ;                otherwise may be "-"
-; sound        = Sound tag for the audio to play when palyer switch
+; sound        = Sound tag for the audio to play when player switch
 ;                to government.
 ; sound_alt    = Alternative sound tag, in case primary one is not found.
 ; sound_alt2   = Second alternative sound tag, in case neither primary tag
diff --git a/data/civ2/governments.ruleset b/data/civ2/governments.ruleset
index ed00e82625..2c5f20801f 100644
--- a/data/civ2/governments.ruleset
+++ b/data/civ2/governments.ruleset
@@ -44,7 +44,7 @@ during_revolution = "Anarchy"
 ; graphic_alt  = alternate graphics tag if preferred is not found;
 ;                should be a standard tag if preferred is not;
 ;                otherwise may be "-"
-; sound        = Sound tag for the audio to play when palyer switch
+; sound        = Sound tag for the audio to play when player switch
 ;                to government.
 ; sound_alt    = Alternative sound tag, in case primary one is not found.
 ; sound_alt2   = Second alternative sound tag, in case neither primary tag
diff --git a/data/civ2civ3/governments.ruleset b/data/civ2civ3/governments.ruleset
index 9c46305f81..69754fe6ef 100644
--- a/data/civ2civ3/governments.ruleset
+++ b/data/civ2civ3/governments.ruleset
@@ -44,7 +44,7 @@ during_revolution = "Anarchy"
 ; graphic_alt  = alternate graphics tag if preferred is not found;
 ;                should be a standard tag if preferred is not;
 ;                otherwise may be "-"
-; sound        = Sound tag for the audio to play when palyer switch
+; sound        = Sound tag for the audio to play when player switch
 ;                to government.
 ; sound_alt    = Alternative sound tag, in case primary one is not found.
 ; sound_alt2   = Second alternative sound tag, in case neither primary tag
diff --git a/data/classic/governments.ruleset b/data/classic/governments.ruleset
index 4a7a83c93e..ac653d551c 100644
--- a/data/classic/governments.ruleset
+++ b/data/classic/governments.ruleset
@@ -44,7 +44,7 @@ during_revolution = "Anarchy"
 ; graphic_alt  = alternate graphics tag if preferred is not found;
 ;                should be a standard tag if preferred is not;
 ;                otherwise may be "-"
-; sound        = Sound tag for the audio to play when palyer switch
+; sound        = Sound tag for the audio to play when player switch
 ;                to government.
 ; sound_alt    = Alternative sound tag, in case primary one is not found.
 ; sound_alt2   = Second alternative sound tag, in case neither primary tag
diff --git a/data/goldkeep/governments.ruleset b/data/goldkeep/governments.ruleset
index 3aaf973e43..2885c72d03 100644
--- a/data/goldkeep/governments.ruleset
+++ b/data/goldkeep/governments.ruleset
@@ -46,7 +46,7 @@ during_revolution = "Anarchy"
 ; graphic_alt  = alternate graphics tag if preferred is not found;
 ;                should be a standard tag if preferred is not;
 ;                otherwise may be "-"
-; sound        = Sound tag for the audio to play when palyer switch
+; sound        = Sound tag for the audio to play when player switch
 ;                to government.
 ; sound_alt    = Alternative sound tag, in case primary one is not found.
 ; sound_alt2   = Second alternative sound tag, in case neither primary tag
diff --git a/data/granularity/governments.ruleset b/data/granularity/governments.ruleset
index 90450b3607..54f2805ffd 100644
--- a/data/granularity/governments.ruleset
+++ b/data/granularity/governments.ruleset
@@ -44,7 +44,7 @@ during_revolution = "Anarchy"
 ; graphic_alt  = alternate graphics tag if preferred is not found;
 ;                should be a standard tag if preferred is not;
 ;                otherwise may be "-"
-; sound        = Sound tag for the audio to play when palyer switch
+; sound        = Sound tag for the audio to play when player switch
 ;                to government.
 ; sound_alt    = Alternative sound tag, in case primary one is not found.
 ; sound_alt2   = Second alternative sound tag, in case neither primary tag
diff --git a/data/multiplayer/governments.ruleset b/data/multiplayer/governments.ruleset
index e03c266038..0b36d77b59 100644
--- a/data/multiplayer/governments.ruleset
+++ b/data/multiplayer/governments.ruleset
@@ -44,7 +44,7 @@ during_revolution = "Anarchy"
 ; graphic_alt  = alternate graphics tag if preferred is not found;
 ;                should be a standard tag if preferred is not;
 ;                otherwise may be "-"
-; sound        = Sound tag for the audio to play when palyer switch
+; sound        = Sound tag for the audio to play when player switch
 ;                to government.
 ; sound_alt    = Alternative sound tag, in case primary one is not found.
 ; sound_alt2   = Second alternative sound tag, in case neither primary tag
diff --git a/data/ruledit/comments-3.3.txt b/data/ruledit/comments-3.3.txt
index 9fd75014ec..6bc05e9c8b 100644
--- a/data/ruledit/comments-3.3.txt
+++ b/data/ruledit/comments-3.3.txt
@@ -194,7 +194,7 @@ governments = "\
 ; graphic_alt  = alternate graphics tag if preferred is not found;\n\
 ;                should be a standard tag if preferred is not;\n\
 ;                otherwise may be \"-\"\n\
-; sound        = Sound tag for the audio to play when palyer switch\n\
+; sound        = Sound tag for the audio to play when player switch\n\
 ;                to government.\n\
 ; sound_alt    = Alternative sound tag, in case primary one is not found.\n\
 ; sound_alt2   = Second alternative sound tag, in case neither primary tag\n\
diff --git a/data/sandbox/governments.ruleset b/data/sandbox/governments.ruleset
index e0ac546d5f..df29e4d00d 100644
--- a/data/sandbox/governments.ruleset
+++ b/data/sandbox/governments.ruleset
@@ -44,7 +44,7 @@ during_revolution = "Anarchy"
 ; graphic_alt  = alternate graphics tag if preferred is not found;
 ;                should be a standard tag if preferred is not;
 ;                otherwise may be "-"
-; sound        = Sound tag for the audio to play when palyer switch
+; sound        = Sound tag for the audio to play when player switch
 ;                to government.
 ; sound_alt    = Alternative sound tag, in case primary one is not found.
 ; sound_alt2   = Second alternative sound tag, in case neither primary tag
diff --git a/data/stub/governments.ruleset b/data/stub/governments.ruleset
index 4813ab050d..20c666ea35 100644
--- a/data/stub/governments.ruleset
+++ b/data/stub/governments.ruleset
@@ -35,7 +35,7 @@ during_revolution = "Anarchy"
 ; graphic_alt  = alternate graphics tag if preferred is not found;
 ;                should be a standard tag if preferred is not;
 ;                otherwise may be "-"
-; sound        = Sound tag for the audio to play when palyer switch
+; sound        = Sound tag for the audio to play when player switch
 ;                to government.
 ; sound_alt    = Alternative sound tag, in case primary one is not found.
 ; sound_alt2   = Second alternative sound tag, in case neither primary tag
diff --git a/data/webperimental/governments.ruleset b/data/webperimental/governments.ruleset
index 587ae5518c..c6069bb2ca 100644
--- a/data/webperimental/governments.ruleset
+++ b/data/webperimental/governments.ruleset
@@ -44,7 +44,7 @@ during_revolution = "Anarchy"
 ; graphic_alt  = alternate graphics tag if preferred is not found;
 ;                should be a standard tag if preferred is not;
 ;                otherwise may be "-"
-; sound        = Sound tag for the audio to play when palyer switch
+; sound        = Sound tag for the audio to play when player switch
 ;                to government.
 ; sound_alt    = Alternative sound tag, in case primary one is not found.
 ; sound_alt2   = Second alternative sound tag, in case neither primary tag
-- 
2.45.2